from diablo2_mod_sql.data.table import DataColumnCollection, DataColumnType

txt_columns_map = {
    'actinfo.txt': DataColumnCollection([
        {'name': 'act', 'type': DataColumnType.INTEGER},
        {'name': 'town', 'type': DataColumnType.STRING},
        {'name': 'start', 'type': DataColumnType.STRING},
        {'name': 'maxnpcitemlevel', 'type': DataColumnType.INTEGER},
        {'name': 'classlevelrangestart', 'type': DataColumnType.STRING},
        {'name': 'classlevelrangeend', 'type': DataColumnType.STRING},
        {'name': 'wanderingnpcstart', 'type': DataColumnType.INTEGER},
        {'name': 'wanderingnpcrange', 'type': DataColumnType.INTEGER},
        {'name': 'commonactcof', 'type': DataColumnType.STRING},
        {'name': 'waypoint1', 'type': DataColumnType.STRING},
        {'name': 'waypoint2', 'type': DataColumnType.STRING},
        {'name': 'waypoint3', 'type': DataColumnType.STRING},
        {'name': 'waypoint4', 'type': DataColumnType.STRING},
        {'name': 'waypoint5', 'type': DataColumnType.STRING},
        {'name': 'waypoint6', 'type': DataColumnType.STRING},
        {'name': 'waypoint7', 'type': DataColumnType.STRING},
        {'name': 'waypoint8', 'type': DataColumnType.STRING},
        {'name': 'waypoint9', 'type': DataColumnType.STRING},
        {'name': 'wanderingMonsterPopulateChance', 'type': DataColumnType.INTEGER},
        {'name': 'wanderingMonsterRegionTotal', 'type': DataColumnType.INTEGER},
        {'name': 'wanderingPopulateRandomChance', 'type': DataColumnType.INTEGER},
    ]),
    'armor.txt': DataColumnCollection([
        {'name': 'name', 'type': DataColumnType.STRING},
        {'name': 'version', 'type': DataColumnType.INTEGER},
        {'name': 'compactsave', 'type': DataColumnType.INTEGER},
        {'name': 'rarity', 'type': DataColumnType.INTEGER},
        {'name': 'spawnable', 'type': DataColumnType.INTEGER},
        {'name': 'minac', 'type': DataColumnType.INTEGER},
        {'name': 'maxac', 'type': DataColumnType.INTEGER},
        {'name': 'speed', 'type': DataColumnType.INTEGER},
        {'name': 'reqstr', 'type': DataColumnType.INTEGER},
        {'name': 'reqdex', 'type': DataColumnType.INTEGER},
        {'name': 'block', 'type': DataColumnType.INTEGER},
        {'name': 'durability', 'type': DataColumnType.INTEGER},
        {'name': 'nodurability', 'type': DataColumnType.INTEGER},
        {'name': 'level', 'type': DataColumnType.INTEGER},
        {'name': 'ShowLevel', 'type': DataColumnType.INTEGER},
        {'name': 'levelreq', 'type': DataColumnType.INTEGER},
        {'name': 'cost', 'type': DataColumnType.INTEGER},
        {'name': 'gamble cost', 'type': DataColumnType.INTEGER},
        {'name': 'code', 'type': DataColumnType.STRING},
        {'name': 'namestr', 'type': DataColumnType.STRING},
        {'name': 'magic lvl', 'type': DataColumnType.INTEGER},
        {'name': 'auto prefix', 'type': DataColumnType.INTEGER},
        {'name': 'alternategfx', 'type': DataColumnType.STRING},
        {'name': 'normcode', 'type': DataColumnType.STRING},
        {'name': 'ubercode', 'type': DataColumnType.STRING},
        {'name': 'ultracode', 'type': DataColumnType.STRING},
        {'name': 'component', 'type': DataColumnType.INTEGER},
        {'name': 'invwidth', 'type': DataColumnType.INTEGER},
        {'name': 'invheight', 'type': DataColumnType.INTEGER},
        {'name': 'hasinv', 'type': DataColumnType.INTEGER},
        {'name': 'gemsockets', 'type': DataColumnType.INTEGER},
        {'name': 'gemapplytype', 'type': DataColumnType.INTEGER},
        {'name': 'flippyfile', 'type': DataColumnType.STRING},
        {'name': 'invfile', 'type': DataColumnType.STRING},
        {'name': 'uniqueinvfile', 'type': DataColumnType.STRING},
        {'name': 'setinvfile', 'type': DataColumnType.STRING},
        {'name': 'rArm', 'type': DataColumnType.INTEGER},
        {'name': 'lArm', 'type': DataColumnType.INTEGER},
        {'name': 'Torso', 'type': DataColumnType.INTEGER},
        {'name': 'Legs', 'type': DataColumnType.INTEGER},
        {'name': 'rSPad', 'type': DataColumnType.INTEGER},
        {'name': 'lSPad', 'type': DataColumnType.INTEGER},
        {'name': 'useable', 'type': DataColumnType.INTEGER},
        {'name': 'stackable', 'type': DataColumnType.INTEGER},
        {'name': 'minstack', 'type': DataColumnType.INTEGER},
        {'name': 'maxstack', 'type': DataColumnType.INTEGER},
        {'name': 'spawnstack', 'type': DataColumnType.INTEGER},
        {'name': 'Transmogrify', 'type': DataColumnType.INTEGER},
        {'name': 'TMogType', 'type': DataColumnType.STRING},
        {'name': 'TMogMin', 'type': DataColumnType.INTEGER},
        {'name': 'TMogMax', 'type': DataColumnType.INTEGER},
        {'name': 'type', 'type': DataColumnType.STRING},
        {'name': 'type2', 'type': DataColumnType.STRING},
        {'name': 'dropsound', 'type': DataColumnType.STRING},
        {'name': 'dropsfxframe', 'type': DataColumnType.INTEGER},
        {'name': 'usesound', 'type': DataColumnType.STRING},
        {'name': 'unique', 'type': DataColumnType.INTEGER},
        {'name': 'transparent', 'type': DataColumnType.INTEGER},
        {'name': 'transtbl', 'type': DataColumnType.INTEGER},
        {'name': '*quivered', 'type': DataColumnType.INTEGER},
        {'name': 'lightradius', 'type': DataColumnType.INTEGER},
        {'name': 'belt', 'type': DataColumnType.INTEGER},
        {'name': 'quest', 'type': DataColumnType.INTEGER},
        {'name': 'questdiffcheck', 'type': DataColumnType.INTEGER},
        {'name': 'missiletype', 'type': DataColumnType.INTEGER},
        {'name': 'durwarning', 'type': DataColumnType.INTEGER},
        {'name': 'qntwarning', 'type': DataColumnType.INTEGER},
        {'name': 'mindam', 'type': DataColumnType.INTEGER},
        {'name': 'maxdam', 'type': DataColumnType.INTEGER},
        {'name': 'StrBonus', 'type': DataColumnType.INTEGER},
        {'name': 'DexBonus', 'type': DataColumnType.INTEGER},
        {'name': 'gemoffset', 'type': DataColumnType.INTEGER},
        {'name': 'bitfield1', 'type': DataColumnType.INTEGER},
        {'name': 'CharsiMin', 'type': DataColumnType.INTEGER},
        {'name': 'CharsiMax', 'type': DataColumnType.INTEGER},
        {'name': 'CharsiMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'CharsiMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'CharsiMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'GheedMin', 'type': DataColumnType.INTEGER},
        {'name': 'GheedMax', 'type': DataColumnType.INTEGER},
        {'name': 'GheedMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'GheedMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'GheedMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'AkaraMin', 'type': DataColumnType.INTEGER},
        {'name': 'AkaraMax', 'type': DataColumnType.INTEGER},
        {'name': 'AkaraMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'AkaraMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'AkaraMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'FaraMin', 'type': DataColumnType.INTEGER},
        {'name': 'FaraMax', 'type': DataColumnType.INTEGER},
        {'name': 'FaraMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'FaraMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'FaraMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'LysanderMin', 'type': DataColumnType.INTEGER},
        {'name': 'LysanderMax', 'type': DataColumnType.INTEGER},
        {'name': 'LysanderMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'LysanderMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'LysanderMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'DrognanMin', 'type': DataColumnType.INTEGER},
        {'name': 'DrognanMax', 'type': DataColumnType.INTEGER},
        {'name': 'DrognanMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'DrognanMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'DrognanMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'HratliMin', 'type': DataColumnType.INTEGER},
        {'name': 'HratliMax', 'type': DataColumnType.INTEGER},
        {'name': 'HratliMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'HratliMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'HratliMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'AlkorMin', 'type': DataColumnType.INTEGER},
        {'name': 'AlkorMax', 'type': DataColumnType.INTEGER},
        {'name': 'AlkorMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'AlkorMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'AlkorMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'OrmusMin', 'type': DataColumnType.INTEGER},
        {'name': 'OrmusMax', 'type': DataColumnType.INTEGER},
        {'name': 'OrmusMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'OrmusMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'OrmusMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'ElzixMin', 'type': DataColumnType.INTEGER},
        {'name': 'ElzixMax', 'type': DataColumnType.INTEGER},
        {'name': 'ElzixMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'ElzixMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'ElzixMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'AshearaMin', 'type': DataColumnType.INTEGER},
        {'name': 'AshearaMax', 'type': DataColumnType.INTEGER},
        {'name': 'AshearaMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'AshearaMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'AshearaMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'CainMin', 'type': DataColumnType.INTEGER},
        {'name': 'CainMax', 'type': DataColumnType.INTEGER},
        {'name': 'CainMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'CainMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'CainMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'HalbuMin', 'type': DataColumnType.INTEGER},
        {'name': 'HalbuMax', 'type': DataColumnType.INTEGER},
        {'name': 'HalbuMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'HalbuMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'HalbuMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'JamellaMin', 'type': DataColumnType.INTEGER},
        {'name': 'JamellaMax', 'type': DataColumnType.INTEGER},
        {'name': 'JamellaMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'JamellaMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'JamellaMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'LarzukMin', 'type': DataColumnType.INTEGER},
        {'name': 'LarzukMax', 'type': DataColumnType.INTEGER},
        {'name': 'LarzukMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'LarzukMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'LarzukMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'MalahMin', 'type': DataColumnType.INTEGER},
        {'name': 'MalahMax', 'type': DataColumnType.INTEGER},
        {'name': 'MalahMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'MalahMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'MalahMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'AnyaMin', 'type': DataColumnType.INTEGER},
        {'name': 'AnyaMax', 'type': DataColumnType.INTEGER},
        {'name': 'AnyaMagicMin', 'type': DataColumnType.INTEGER},
        {'name': 'AnyaMagicMax', 'type': DataColumnType.INTEGER},
        {'name': 'AnyaMagicLvl', 'type': DataColumnType.INTEGER},
        {'name': 'Transform', 'type': DataColumnType.INTEGER},
        {'name': 'InvTrans', 'type': DataColumnType.INTEGER},
        {'name': 'SkipName', 'type': DataColumnType.INTEGER},
        {'name': 'NightmareUpgrade', 'type': DataColumnType.STRING},
        {'name': 'HellUpgrade', 'type': DataColumnType.STRING},
        {'name': 'Nameable', 'type': DataColumnType.INTEGER},
        {'name': 'PermStoreItem', 'type': DataColumnType.INTEGER},
        {'name': 'diablocloneweight', 'type': DataColumnType.INTEGER},
    ]),
    'armtype.txt': DataColumnCollection([
        {'name': 'Name', 'type': DataColumnType.STRING},
        {'name': 'Token', 'type': DataColumnType.STRING},
    ]),
    'automagic.txt': DataColumnCollection([
        {'name': 'Name', 'type': DataColumnType.STRING},
        {'name': 'version', 'type': DataColumnType.INTEGER},
        {'name': 'spawnable', 'type': DataColumnType.INTEGER},
        {'name': 'rare', 'type': DataColumnType.INTEGER},
        {'name': 'level', 'type': DataColumnType.INTEGER},
        {'name': 'maxlevel', 'type': DataColumnType.INTEGER},
        {'name': 'levelreq', 'type': DataColumnType.INTEGER},
        {'name': 'classspecific', 'type': DataColumnType.INTEGER},
        {'name': 'class', 'type': DataColumnType.INTEGER},
        {'name': 'classlevelreq', 'type': DataColumnType.INTEGER},
        {'name': 'frequency', 'type': DataColumnType.INTEGER},
        {'name': 'group', 'type': DataColumnType.INTEGER},
        {'name': 'mod1code', 'type': DataColumnType.STRING},
        {'name': 'mod1param', 'type': DataColumnType.INTEGER},
        {'name': 'mod1min', 'type': DataColumnType.INTEGER},
        {'name': 'mod1max', 'type': DataColumnType.INTEGER},
        {'name': 'mod2code', 'type': DataColumnType.STRING},
        {'name': 'mod2param', 'type': DataColumnType.INTEGER},
        {'name': 'mod2min', 'type': DataColumnType.INTEGER},
        {'name': 'mod2max', 'type': DataColumnType.INTEGER},
        {'name': 'mod3code', 'type': DataColumnType.STRING},
        {'name': 'mod3param', 'type': DataColumnType.INTEGER},
        {'name': 'mod3min', 'type': DataColumnType.INTEGER},
        {'name': 'mod3max', 'type': DataColumnType.INTEGER},
        {'name': 'transformcolor', 'type': DataColumnType.STRING},
        {'name': 'itype1', 'type': DataColumnType.STRING},
        {'name': 'itype2', 'type': DataColumnType.STRING},
        {'name': 'itype3', 'type': DataColumnType.STRING},
        {'name': 'itype4', 'type': DataColumnType.STRING},
        {'name': 'itype5', 'type': DataColumnType.STRING},
        {'name': 'itype6', 'type': DataColumnType.STRING},
        {'name': 'itype7', 'type': DataColumnType.STRING},
        {'name': 'etype1', 'type': DataColumnType.STRING},
        {'name': 'etype2', 'type': DataColumnType.STRING},
        {'name': 'etype3', 'type': DataColumnType.STRING},
        {'name': 'etype4', 'type': DataColumnType.STRING},
        {'name': 'etype5', 'type': DataColumnType.STRING},
        {'name': 'multiply', 'type': DataColumnType.INTEGER},
        {'name': 'add', 'type': DataColumnType.INTEGER},
    ]),
    'automap.txt': DataColumnCollection([
        {'name': 'LevelName', 'type': DataColumnType.STRING},
        {'name': 'TileName', 'type': DataColumnType.STRING},
        {'name': 'Style', 'type': DataColumnType.INTEGER},
        {'name': 'StartSequence', 'type': DataColumnType.INTEGER},
        {'name': 'EndSequence', 'type': DataColumnType.INTEGER},
        {'name': '*Type1', 'type': DataColumnType.STRING},
        {'name': 'Cel1', 'type': DataColumnType.INTEGER},
        {'name': '*Type2', 'type': DataColumnType.STRING},
        {'name': 'Cel2', 'type': DataColumnType.INTEGER},
        {'name': '*Type3', 'type': DataColumnType.STRING},
        {'name': 'Cel3', 'type': DataColumnType.INTEGER},
        {'name': '*Type4', 'type': DataColumnType.STRING},
        {'name': 'Cel4', 'type': DataColumnType.INTEGER},
    ]),
    'belts.txt': DataColumnCollection([
        {'name': 'name', 'type': DataColumnType.STRING},
        {'name': 'numboxes', 'type': DataColumnType.INTEGER},
        {'name': 'box1left', 'type': DataColumnType.INTEGER},
        {'name': 'box1right', 'type': DataColumnType.INTEGER},
        {'name': 'box1top', 'type': DataColumnType.INTEGER},
        {'name': 'box1bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box2left', 'type': DataColumnType.INTEGER},
        {'name': 'box2right', 'type': DataColumnType.INTEGER},
        {'name': 'box2top', 'type': DataColumnType.INTEGER},
        {'name': 'box2bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box3left', 'type': DataColumnType.INTEGER},
        {'name': 'box3right', 'type': DataColumnType.INTEGER},
        {'name': 'box3top', 'type': DataColumnType.INTEGER},
        {'name': 'box3bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box4left', 'type': DataColumnType.INTEGER},
        {'name': 'box4right', 'type': DataColumnType.INTEGER},
        {'name': 'box4top', 'type': DataColumnType.INTEGER},
        {'name': 'box4bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box5left', 'type': DataColumnType.INTEGER},
        {'name': 'box5right', 'type': DataColumnType.INTEGER},
        {'name': 'box5top', 'type': DataColumnType.INTEGER},
        {'name': 'box5bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box6left', 'type': DataColumnType.INTEGER},
        {'name': 'box6right', 'type': DataColumnType.INTEGER},
        {'name': 'box6top', 'type': DataColumnType.INTEGER},
        {'name': 'box6bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box7left', 'type': DataColumnType.INTEGER},
        {'name': 'box7right', 'type': DataColumnType.INTEGER},
        {'name': 'box7top', 'type': DataColumnType.INTEGER},
        {'name': 'box7bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box8left', 'type': DataColumnType.INTEGER},
        {'name': 'box8right', 'type': DataColumnType.INTEGER},
        {'name': 'box8top', 'type': DataColumnType.INTEGER},
        {'name': 'box8bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box9left', 'type': DataColumnType.INTEGER},
        {'name': 'box9right', 'type': DataColumnType.INTEGER},
        {'name': 'box9top', 'type': DataColumnType.INTEGER},
        {'name': 'box9bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box10left', 'type': DataColumnType.INTEGER},
        {'name': 'box10right', 'type': DataColumnType.INTEGER},
        {'name': 'box10top', 'type': DataColumnType.INTEGER},
        {'name': 'box10bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box11left', 'type': DataColumnType.INTEGER},
        {'name': 'box11right', 'type': DataColumnType.INTEGER},
        {'name': 'box11top', 'type': DataColumnType.INTEGER},
        {'name': 'box11bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box12left', 'type': DataColumnType.INTEGER},
        {'name': 'box12right', 'type': DataColumnType.INTEGER},
        {'name': 'box12top', 'type': DataColumnType.INTEGER},
        {'name': 'box12bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box13left', 'type': DataColumnType.INTEGER},
        {'name': 'box13right', 'type': DataColumnType.INTEGER},
        {'name': 'box13top', 'type': DataColumnType.INTEGER},
        {'name': 'box13bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box14left', 'type': DataColumnType.INTEGER},
        {'name': 'box14right', 'type': DataColumnType.INTEGER},
        {'name': 'box14top', 'type': DataColumnType.INTEGER},
        {'name': 'box14bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box15left', 'type': DataColumnType.INTEGER},
        {'name': 'box15right', 'type': DataColumnType.INTEGER},
        {'name': 'box15top', 'type': DataColumnType.INTEGER},
        {'name': 'box15bottom', 'type': DataColumnType.INTEGER},
        {'name': 'box16left', 'type': DataColumnType.INTEGER},
        {'name': 'box16right', 'type': DataColumnType.INTEGER},
        {'name': 'box16top', 'type': DataColumnType.INTEGER},
        {'name': 'box16bottom', 'type': DataColumnType.INTEGER},
        {'name': 'defaultItemTypeCol1', 'type': DataColumnType.STRING},
        {'name': 'defaultItemCodeCol1', 'type': DataColumnType.INTEGER},
        {'name': 'defaultItemTypeCol2', 'type': DataColumnType.STRING},
        {'name': 'defaultItemCodeCol2', 'type': DataColumnType.INTEGER},
        {'name': 'defaultItemTypeCol3', 'type': DataColumnType.STRING},
        {'name': 'defaultItemCodeCol3', 'type': DataColumnType.INTEGER},
        {'name': 'defaultItemTypeCol4', 'type': DataColumnType.STRING},
        {'name': 'defaultItemCodeCol4', 'type': DataColumnType.INTEGER},
    ]),
}
